;;
;;
  (define (pull-data x)
    (cond
     ((pair? x) (car x))
     ((vector? x) (vector-ref x 0))
     (else x)))
;;
  (define (op-func func1 func2 a b)
    (let*
        ((da (pull-data a))
         (db (pull-data b)))
      (cond
       ((string? da) (func1 da db))
       ((number? da) (func2 da db))
       (else (display "ERR in op-func") (newline) #f))))
;;
  (define (op< a b)   (op-func string<? < a b))
  (define (op= a b)   (op-func string=? = a b))
  (define (op<= a b)  (op-func string<=? <= a b))
  (define (opn= a b)  (not (op= a b)))
  (define (op> a b)   (not (op<= a b)))
  (define (op>= a b)  (not (op< a b)))
;; ---------------------------------------------------------------
;;
;;
(define (tree01)
  (define seed '())
  (define ans   #f)
  (define n      0)
  (define (make-node x) (vector x '() '()))
  (define (get-key p) (vector-ref p 0))
  (define (set-key! p x) (vector-set! p 0 x))
  (define (get-l p) (vector-ref p 1))
  (define (set-l! p q) (vector-set! p 1 q))
  (define (get-r p) (vector-ref p 2))
  (define (set-r! p q) (vector-set! p 2 q))
;;
  (define (insert-drv p x)
    (cond
     ((null? p) (set! ans #t) (set! n (+ n 1)) (make-node x))
     ((op= x (get-key p)) (set! ans #f) p)
     (else
      (cond
       ((op< x (get-key p)) (set-l! p (insert-drv (get-l p) x)) p)
       (else                (set-r! p (insert-drv (get-r p) x)) p)))))
;;
  (define (lookup-drv p x)
    (cond
     ((null? p) (set! ans #f))
     ((op= x (get-key p)) (set! ans (get-key p)))
     ((op< x (get-key p)) (lookup-drv (get-l p) x))
     (else                (lookup-drv (get-r p) x))))
;;
  (define (show-drv p)
    (if (not (null? p))
        (begin  (show-drv (get-l p))
                (display (pull-data (get-key p)))
                (display " ")
                (show-drv (get-r p)))))
;;
  (define (swap-key p)
    (do
        ((tmp  (get-key p))
         (q (get-l p) (get-r q)))
        ((null? (get-r q))
         (set-key! p (get-key q))
         (set-key! q tmp))))
;;
  (define (delete-drv p x)
    (cond
     ((null? p) (set! ans #f) '())
     ((op= x (get-key p))
      (set! ans (get-key p))
      (cond
       ((null? (get-l p)) (set! n (- n 1)) (get-r p))
       ((null? (get-r p)) (set! n (- n 1)) (get-l p))
       (else
        (swap-key p)
        (set-l! p (delete-drv (get-l p) x))
        p)))
     (else
      (cond
       ((op< x (get-key p)) (set-l! p (delete-drv (get-l p) x)))
       (else                (set-r! p (delete-drv (get-r p) x))))
      p)))
;;
  (define (find-min-drv p)
    (do
        ((q p (get-l q)))
        ((null? (get-l q)) (set! ans (get-key q)))))
;;
  (define (find-min)
    (cond
     ((null? seed) (set! ans #f))
     (else
      (find-min-drv seed)))
    ans)
;;
  (define (delete-min)
    (find-min)
    (if ans (set! seed (delete-drv seed ans)) (set! ans #f)))
;;
;;
  (define (dispatch m . a)
    (cond
     ((eq? m 'show)    (show-drv seed) (newline))
     ((eq? m 'insert)  (set! seed (insert-drv seed (car a))) ans)
     ((eq? m 'lookup) (lookup-drv seed (car a)) ans)
     ((eq? m 'delete) (set! seed (delete-drv seed (car a))) ans)
     ((eq? m 'count)  n)
     ((eq? m 'clear)  (set! seed '()) (set! n 0))
     ((eq? m 'find-min) (find-min-drv seed) ans)
     ((eq? m 'delete-min) (delete-min) ans)
     (else  (display "ERR: nono\n"))))
;;
  dispatch)

  

